(function(){"use strict";try{if(typeof document!="undefined"){var e=document.createElement("style");e.appendChild(document.createTextNode(".mk-input{min-height:1.4em}.mk-input span{outline:none;white-space:pre-wrap}.mk-suggestions{border:1px solid #ccc;max-height:186px;overflow-y:auto;padding-left:0;position:absolute;background:white;width:fit-content;min-width:100px;margin-top:0;margin-bottom:0;transition:1.1s ease-out;filter:blur(0);transform:scale(1);opacity:1;visibility:visible;color:#000;border-radius:4%;box-shadow:0 3px 6px -2px #0009}.mk-suggestions li{padding:.5rem}.mk-suggestions li:hover,.mk-suggestion-active{background-color:#cce9ff;color:#2589f5;cursor:pointer}")),document.head.appendChild(e)}}catch(i){console.error("vite-plugin-css-injected-by-js",i)}})();
import Se, { useContext as zt, Children as Gt, isValidElement as rt, useRef as K, useEffect as ae, useLayoutEffect as Kt, useState as ie, useCallback as J, memo as ut, useMemo as G, forwardRef as Ht } from "react";
const Y = {
  UP: "ArrowUp",
  DOWN: "ArrowDown",
  LEFT: "ArrowLeft",
  RIGHT: "ArrowRight",
  END: "End",
  HOME: "Home",
  PAGE_DOWN: "PageDown",
  PAGE_UP: "PageUp",
  ENTER: "Enter",
  TAB: "Tab",
  SPACE: " ",
  BACKSPACE: "Backspace",
  DELETE: "Delete",
  COMMA: ",",
  ESC: "Escape"
};
var B = /* @__PURE__ */ ((r) => (r.LABEL = "__label__", r.VALUE = "__value__", r))(B || {});
const nt = "mk-input", it = {
  trigger: "@",
  markup: "@[__label__](__value__)",
  data: [],
  index: 0
}, qt = ["onFocus", "onBlur", "onKeyDown", "onClick"], Jt = new RegExp(/^\w*/);
class Xt {
  constructor(e, t) {
    this.raw = e, this.uniRegExp = t, this.done = !1;
  }
  [Symbol.iterator]() {
    return this;
  }
  next() {
    if (this.done)
      return { done: this.done, value: null };
    let e = this.uniRegExp.exec(this.raw);
    if (e === null)
      return this.done = !0, { done: !1, value: [this.raw, null] };
    let [t, n, a] = this.extractPieces(e);
    return this.raw = a, { done: !1, value: [t, n] };
  }
  extractPieces(e) {
    const t = this.extractMark(e), n = t.input.substring(0, t.index), a = t.input.substring(t.index + t.annotation.length);
    return [n, t, a];
  }
  extractMark(e) {
    let t = e[0], n = 0, a = e[1], o = e[2];
    for (; !(a || o); )
      n++, a = e[2 * n + 1], o = e[2 * n + 2];
    let c = e.index, l = e.input;
    return { annotation: t, label: a, value: o, input: l, index: c, childIndex: n };
  }
}
class pe {
  get regExps() {
    return this.markups.map(Zt);
  }
  static split(e, t) {
    const n = t.map((a) => a.markup);
    return () => new pe(n).split(e);
  }
  constructor(e) {
    this.markups = e, this.uniRegExp = new RegExp(this.regExps.map((t) => t.source).join("|"));
  }
  split(e) {
    return this.iterateMatches(e);
  }
  iterateMatches(e) {
    const t = [];
    for (let [n, a] of new Xt(e, this.uniRegExp))
      t.push(n), a !== null && t.push(Qt(a, this.markups[a.childIndex]));
    return t;
  }
}
const ct = Object.assign, Zt = (r) => {
  const e = he(r), t = r[r.indexOf(B.LABEL) + B.LABEL.length], n = r[r.indexOf(B.VALUE) + B.VALUE.length];
  return new RegExp(
    e.replace(B.LABEL, `([^${he(t || "")}]+?)`).replace(B.VALUE, `([^${he(n || "")}]+?)`)
  );
};
function ke(r, e, t) {
  let n = r.replace(B.LABEL, e);
  return t ? n.replace(B.VALUE, t) : n;
}
function Ur(r, e, ...t) {
  return t.length ? new pe(t).split(r).reduce((a, o) => a += Pe(o) ? e(o) : o, "") : r;
}
const he = (r) => r.replace(/[-[\]{}()*+?.,\\^$|#\s]/g, "\\$&");
function at(r, e) {
  let t = "";
  for (let n of r)
    t += ft(n) ? ke(e[n.childIndex].markup, n.label, n.value) : n.label;
  return t;
}
const Qt = (r, e) => r.annotation !== ke(e, r.label, r.value) ? { ...r, label: r.value, value: r.label } : r, st = (r, e = 0) => {
  let t = 3735928559 ^ e, n = 1103547991 ^ e;
  for (let a = 0, o; a < r.length; a++)
    o = r.charCodeAt(a), t = Math.imul(t ^ o, 2654435761), n = Math.imul(n ^ o, 1597334677);
  return t = Math.imul(t ^ t >>> 16, 2246822507) ^ Math.imul(n ^ n >>> 13, 3266489909), n = Math.imul(n ^ n >>> 16, 2246822507) ^ Math.imul(t ^ t >>> 13, 3266489909), 4294967296 * (2097151 & n) + (t >>> 0);
}, Pe = (r) => typeof r == "object", ft = (r) => r !== null && typeof r == "object" && "annotation" in r, er = (r) => typeof r == "function", tr = (r) => typeof r == "string" && r.startsWith("on"), rr = (r) => rt(r) ? !0 : rt(r == null ? void 0 : r[0]);
function nr(r) {
  if (rr(r))
    return Gt.map(r, (t, n) => e(t.props, n));
  if (r != null && r.length)
    return r.map(e);
  return [it];
  function e(t, n) {
    return ct({}, it, t, { index: n });
  }
}
const dt = (r) => {
  const e = Se.createContext(void 0);
  return e.displayName = r, [a(e), e];
  function a(o) {
    return () => {
      const c = zt(o);
      if (c)
        return c;
      throw new Error(`The context ${o.displayName} didn't found!`);
    };
  }
}, [O, ir] = dt("MarkedInputStoreProvider"), [ge, ar] = dt("PiecesProvider");
function sr(r, e, t = !0) {
  let n;
  return () => {
    const o = t && !n;
    clearTimeout(n), n = setTimeout(a, e), o && r.apply(arguments);
  };
  function a() {
    n = void 0, t || r(arguments);
  }
}
function or(r, e, t, n) {
  return r.slice(0, t) + e + r.slice(t + n.length);
}
function lr(r, e) {
  const t = Pe(r) ? r.label + r.value : r;
  let n = 0, a = st(t, n);
  for (; e.has(a); )
    a = st(t, n++);
  return a;
}
class M {
  static get isSelectedPosition() {
    const e = window.getSelection();
    if (!!e)
      return e.isCollapsed;
  }
  static getCurrentPosition() {
    var e, t;
    return (t = (e = window.getSelection()) == null ? void 0 : e.anchorOffset) != null ? t : 0;
  }
  static getFocusedSpan() {
    var e, t, n;
    return (n = (t = (e = window.getSelection()) == null ? void 0 : e.anchorNode) == null ? void 0 : t.textContent) != null ? n : "";
  }
  static getSelectedNode() {
    var t;
    const e = (t = window.getSelection()) == null ? void 0 : t.anchorNode;
    if (e)
      return e;
    throw new Error("Anchor node of selection is not exists!");
  }
  static getAbsolutePosition() {
    var t, n, a;
    const e = (a = (t = window.getSelection()) == null ? void 0 : (n = t.getRangeAt(0)).getBoundingClientRect) == null ? void 0 : a.call(n);
    return e ? {
      left: e.left,
      top: e.top + e.height + 1
    } : {
      left: 0,
      top: 0
    };
  }
  static trySetIndex(e, t) {
    try {
      this.setIndex(e, t);
    } catch (n) {
      console.error(n);
    }
  }
  static setIndex(e, t) {
    const n = window.getSelection();
    if (!(n != null && n.anchorNode) || !n.rangeCount)
      return;
    const a = n.getRangeAt(0);
    a == null || a.setStart(e.firstChild || e, t), a == null || a.setEnd(e.firstChild || e, t);
  }
  static getCaretIndex(e) {
    let t = 0;
    const n = window.getSelection();
    if (!(n != null && n.rangeCount))
      return t;
    const a = n.getRangeAt(0), o = a.cloneRange();
    return o.selectNodeContents(e), o.setEnd(a.endContainer, a.endOffset), t = o.toString().length, t;
  }
  static setCaretToEnd(e) {
    if (!e)
      return;
    const t = window.getSelection();
    t == null || t.setPosition(e, 1);
  }
  static getIndex() {
    var t;
    const e = window.getSelection();
    return (t = e == null ? void 0 : e.anchorOffset) != null ? t : NaN;
  }
  static setIndex1(e) {
    const t = window.getSelection();
    if (!(t != null && t.anchorNode) || !t.rangeCount)
      return;
    const n = t.getRangeAt(0);
    n == null || n.setStart(n.startContainer.firstChild || n.startContainer, e), n == null || n.setEnd(n.startContainer.firstChild || n.startContainer, e);
  }
  setCaretRightTo(e, t) {
    const n = window.getSelection(), a = n == null ? void 0 : n.getRangeAt(0);
    a == null || a.setStart(a.endContainer, t), a == null || a.setEnd(a.endContainer, t);
  }
}
const ur = () => {
  const r = ge(), e = K(null);
  return ae(() => {
    var t, n;
    if (e.current) {
      const {
        prevNodeData: a,
        caretPosition: o
      } = e.current, c = r.findNode((v) => v === a), l = (t = c == null ? void 0 : c.next) != null ? t : r.head, f = (n = l == null ? void 0 : l.data.ref) == null ? void 0 : n.current;
      f == null || f.focus(), f && M.trySetIndex(f, o), e.current = null;
    }
  }), e;
};
function F(r, e, t, n) {
  const {
    bus: a
  } = n != null ? n : O();
  ae(() => a.listen(r, e), t);
}
const cr = () => {
  const r = ge(), e = K();
  return F("onFocus", (t) => e.current = r.findNode((n) => {
    var a;
    return ((a = n.ref) == null ? void 0 : a.current) === t.target;
  }), [r]), F("onBlur", (t) => e.current = void 0, []), e;
};
var R = /* @__PURE__ */ ((r) => (r[r.Change = 0] = "Change", r[r.Delete = 1] = "Delete", r[r.CheckTrigger = 2] = "CheckTrigger", r[r.ClearTrigger = 3] = "ClearTrigger", r[r.Select = 4] = "Select", r))(R || {});
function fr(r, e) {
  const {
    bus: t
  } = O();
  F("onKeyDown", (n) => {
    var A, L;
    const a = n.target, o = M.getCaretIndex(a), c = o === 0, l = o === ((A = a.textContent) == null ? void 0 : A.length), f = {
      [Y.LEFT]: c ? v : null,
      [Y.RIGHT]: l ? w : null,
      [Y.UP]: null,
      [Y.DOWN]: null,
      [Y.DELETE]: l ? S : null,
      [Y.BACKSPACE]: c ? y : null
    };
    (L = f[n.key]) == null || L.call(f);
    function v() {
      var _, E, N, D, I;
      const m = (_ = e.current) == null ? void 0 : _.prev, P = (I = (E = m == null ? void 0 : m.data.ref) == null ? void 0 : E.current) != null ? I : (D = (N = m == null ? void 0 : m.prev) == null ? void 0 : N.data.ref) == null ? void 0 : D.current;
      P == null || P.focus(), M.setCaretToEnd(P), n.preventDefault();
    }
    function w() {
      var _, E, N, D, I;
      const m = (_ = e.current) == null ? void 0 : _.next, P = (I = (E = m == null ? void 0 : m.data.ref) == null ? void 0 : E.current) != null ? I : (D = (N = m == null ? void 0 : m.next) == null ? void 0 : N.data.ref) == null ? void 0 : D.current;
      P == null || P.focus(), n.preventDefault();
    }
    function y() {
      var _, E, N, D, I;
      const m = (_ = e.current) == null ? void 0 : _.prev;
      if (!(m != null && m.data.key))
        return;
      const P = (N = (E = m.prev) == null ? void 0 : E.data.piece.label.length) != null ? N : 0;
      r.current = {
        prevNodeData: (I = (D = m.prev) == null ? void 0 : D.prev) == null ? void 0 : I.data,
        caretPosition: P
      }, t.send(R.Delete, {
        key: m.data.key
      }), n.preventDefault();
    }
    function S() {
      var _, E, N, D, I;
      const m = (_ = e.current) == null ? void 0 : _.next;
      if (!(m != null && m.data.key))
        return;
      const P = (N = (E = m.prev) == null ? void 0 : E.data.piece.label.length) != null ? N : 0;
      r.current = {
        prevNodeData: (I = (D = m.prev) == null ? void 0 : D.prev) == null ? void 0 : I.data,
        caretPosition: P
      }, t.send(R.Delete, {
        key: m.data.key
      }), n.preventDefault();
    }
  }, []);
}
const dr = () => {
  const r = ge();
  F("onClick", () => {
    var e, t, n, a;
    r.length === 1 && ((e = r.head) == null ? void 0 : e.data.piece.label) === "" && ((a = (n = (t = r.head) == null ? void 0 : t.data.ref) == null ? void 0 : n.current) == null || a.focus());
  }, [r]);
}, hr = () => {
  const r = cr(), e = ur();
  fr(e, r), dr();
};
function vr() {
  const {
    bus: r
  } = O(), e = K(null);
  return ae(() => r.set("TextRef", e), []), e;
}
var Te = { exports: {} }, Q = {};
/**
 * @license React
 * react-jsx-runtime.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var ot;
function pr() {
  if (ot)
    return Q;
  ot = 1;
  var r = Se, e = Symbol.for("react.element"), t = Symbol.for("react.fragment"), n = Object.prototype.hasOwnProperty, a = r.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED.ReactCurrentOwner, o = { key: !0, ref: !0, __self: !0, __source: !0 };
  function c(l, f, v) {
    var w, y = {}, S = null, A = null;
    v !== void 0 && (S = "" + v), f.key !== void 0 && (S = "" + f.key), f.ref !== void 0 && (A = f.ref);
    for (w in f)
      n.call(f, w) && !o.hasOwnProperty(w) && (y[w] = f[w]);
    if (l && l.defaultProps)
      for (w in f = l.defaultProps, f)
        y[w] === void 0 && (y[w] = f[w]);
    return { $$typeof: e, type: l, key: S, ref: A, props: y, _owner: a.current };
  }
  return Q.Fragment = t, Q.jsx = c, Q.jsxs = c, Q;
}
var ee = {};
/**
 * @license React
 * react-jsx-runtime.development.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var lt;
function gr() {
  return lt || (lt = 1, process.env.NODE_ENV !== "production" && function() {
    var r = Se, e = Symbol.for("react.element"), t = Symbol.for("react.portal"), n = Symbol.for("react.fragment"), a = Symbol.for("react.strict_mode"), o = Symbol.for("react.profiler"), c = Symbol.for("react.provider"), l = Symbol.for("react.context"), f = Symbol.for("react.forward_ref"), v = Symbol.for("react.suspense"), w = Symbol.for("react.suspense_list"), y = Symbol.for("react.memo"), S = Symbol.for("react.lazy"), A = Symbol.for("react.offscreen"), L = Symbol.iterator, m = "@@iterator";
    function P(i) {
      if (i === null || typeof i != "object")
        return null;
      var s = L && i[L] || i[m];
      return typeof s == "function" ? s : null;
    }
    var _ = r.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED;
    function E(i) {
      {
        for (var s = arguments.length, u = new Array(s > 1 ? s - 1 : 0), d = 1; d < s; d++)
          u[d - 1] = arguments[d];
        N("error", i, u);
      }
    }
    function N(i, s, u) {
      {
        var d = _.ReactDebugCurrentFrame, g = d.getStackAddendum();
        g !== "" && (s += "%s", u = u.concat([g]));
        var x = u.map(function(p) {
          return String(p);
        });
        x.unshift("Warning: " + s), Function.prototype.apply.call(console[i], console, x);
      }
    }
    var D = !1, I = !1, pt = !1, gt = !1, mt = !1, Ne;
    Ne = Symbol.for("react.module.reference");
    function Et(i) {
      return !!(typeof i == "string" || typeof i == "function" || i === n || i === o || mt || i === a || i === v || i === w || gt || i === A || D || I || pt || typeof i == "object" && i !== null && (i.$$typeof === S || i.$$typeof === y || i.$$typeof === c || i.$$typeof === l || i.$$typeof === f || i.$$typeof === Ne || i.getModuleId !== void 0));
    }
    function xt(i, s, u) {
      var d = i.displayName;
      if (d)
        return d;
      var g = s.displayName || s.name || "";
      return g !== "" ? u + "(" + g + ")" : u;
    }
    function De(i) {
      return i.displayName || "Context";
    }
    function W(i) {
      if (i == null)
        return null;
      if (typeof i.tag == "number" && E("Received an unexpected object in getComponentNameFromType(). This is likely a bug in React. Please file an issue."), typeof i == "function")
        return i.displayName || i.name || null;
      if (typeof i == "string")
        return i;
      switch (i) {
        case n:
          return "Fragment";
        case t:
          return "Portal";
        case o:
          return "Profiler";
        case a:
          return "StrictMode";
        case v:
          return "Suspense";
        case w:
          return "SuspenseList";
      }
      if (typeof i == "object")
        switch (i.$$typeof) {
          case l:
            var s = i;
            return De(s) + ".Consumer";
          case c:
            var u = i;
            return De(u._context) + ".Provider";
          case f:
            return xt(i, i.render, "ForwardRef");
          case y:
            var d = i.displayName || null;
            return d !== null ? d : W(i.type) || "Memo";
          case S: {
            var g = i, x = g._payload, p = g._init;
            try {
              return W(p(x));
            } catch {
              return null;
            }
          }
        }
      return null;
    }
    var U = Object.assign, X = 0, Ie, je, Fe, Me, Le, We, $e;
    function Be() {
    }
    Be.__reactDisabledLog = !0;
    function wt() {
      {
        if (X === 0) {
          Ie = console.log, je = console.info, Fe = console.warn, Me = console.error, Le = console.group, We = console.groupCollapsed, $e = console.groupEnd;
          var i = {
            configurable: !0,
            enumerable: !0,
            value: Be,
            writable: !0
          };
          Object.defineProperties(console, {
            info: i,
            log: i,
            warn: i,
            error: i,
            group: i,
            groupCollapsed: i,
            groupEnd: i
          });
        }
        X++;
      }
    }
    function yt() {
      {
        if (X--, X === 0) {
          var i = {
            configurable: !0,
            enumerable: !0,
            writable: !0
          };
          Object.defineProperties(console, {
            log: U({}, i, {
              value: Ie
            }),
            info: U({}, i, {
              value: je
            }),
            warn: U({}, i, {
              value: Fe
            }),
            error: U({}, i, {
              value: Me
            }),
            group: U({}, i, {
              value: Le
            }),
            groupCollapsed: U({}, i, {
              value: We
            }),
            groupEnd: U({}, i, {
              value: $e
            })
          });
        }
        X < 0 && E("disabledDepth fell below zero. This is a bug in React. Please file an issue.");
      }
    }
    var me = _.ReactCurrentDispatcher, Ee;
    function se(i, s, u) {
      {
        if (Ee === void 0)
          try {
            throw Error();
          } catch (g) {
            var d = g.stack.trim().match(/\n( *(at )?)/);
            Ee = d && d[1] || "";
          }
        return `
` + Ee + i;
      }
    }
    var xe = !1, oe;
    {
      var bt = typeof WeakMap == "function" ? WeakMap : Map;
      oe = new bt();
    }
    function Ve(i, s) {
      if (!i || xe)
        return "";
      {
        var u = oe.get(i);
        if (u !== void 0)
          return u;
      }
      var d;
      xe = !0;
      var g = Error.prepareStackTrace;
      Error.prepareStackTrace = void 0;
      var x;
      x = me.current, me.current = null, wt();
      try {
        if (s) {
          var p = function() {
            throw Error();
          };
          if (Object.defineProperty(p.prototype, "props", {
            set: function() {
              throw Error();
            }
          }), typeof Reflect == "object" && Reflect.construct) {
            try {
              Reflect.construct(p, []);
            } catch ($) {
              d = $;
            }
            Reflect.construct(i, [], p);
          } else {
            try {
              p.call();
            } catch ($) {
              d = $;
            }
            i.call(p.prototype);
          }
        } else {
          try {
            throw Error();
          } catch ($) {
            d = $;
          }
          i();
        }
      } catch ($) {
        if ($ && d && typeof $.stack == "string") {
          for (var h = $.stack.split(`
`), k = d.stack.split(`
`), b = h.length - 1, C = k.length - 1; b >= 1 && C >= 0 && h[b] !== k[C]; )
            C--;
          for (; b >= 1 && C >= 0; b--, C--)
            if (h[b] !== k[C]) {
              if (b !== 1 || C !== 1)
                do
                  if (b--, C--, C < 0 || h[b] !== k[C]) {
                    var j = `
` + h[b].replace(" at new ", " at ");
                    return i.displayName && j.includes("<anonymous>") && (j = j.replace("<anonymous>", i.displayName)), typeof i == "function" && oe.set(i, j), j;
                  }
                while (b >= 1 && C >= 0);
              break;
            }
        }
      } finally {
        xe = !1, me.current = x, yt(), Error.prepareStackTrace = g;
      }
      var q = i ? i.displayName || i.name : "", tt = q ? se(q) : "";
      return typeof i == "function" && oe.set(i, tt), tt;
    }
    function Ct(i, s, u) {
      return Ve(i, !1);
    }
    function _t(i) {
      var s = i.prototype;
      return !!(s && s.isReactComponent);
    }
    function le(i, s, u) {
      if (i == null)
        return "";
      if (typeof i == "function")
        return Ve(i, _t(i));
      if (typeof i == "string")
        return se(i);
      switch (i) {
        case v:
          return se("Suspense");
        case w:
          return se("SuspenseList");
      }
      if (typeof i == "object")
        switch (i.$$typeof) {
          case f:
            return Ct(i.render);
          case y:
            return le(i.type, s, u);
          case S: {
            var d = i, g = d._payload, x = d._init;
            try {
              return le(x(g), s, u);
            } catch {
            }
          }
        }
      return "";
    }
    var ue = Object.prototype.hasOwnProperty, Ue = {}, Ye = _.ReactDebugCurrentFrame;
    function ce(i) {
      if (i) {
        var s = i._owner, u = le(i.type, i._source, s ? s.type : null);
        Ye.setExtraStackFrame(u);
      } else
        Ye.setExtraStackFrame(null);
    }
    function Rt(i, s, u, d, g) {
      {
        var x = Function.call.bind(ue);
        for (var p in i)
          if (x(i, p)) {
            var h = void 0;
            try {
              if (typeof i[p] != "function") {
                var k = Error((d || "React class") + ": " + u + " type `" + p + "` is invalid; it must be a function, usually from the `prop-types` package, but received `" + typeof i[p] + "`.This often happens because of typos such as `PropTypes.function` instead of `PropTypes.func`.");
                throw k.name = "Invariant Violation", k;
              }
              h = i[p](s, p, d, u, null, "SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED");
            } catch (b) {
              h = b;
            }
            h && !(h instanceof Error) && (ce(g), E("%s: type specification of %s `%s` is invalid; the type checker function must return `null` or an `Error` but returned a %s. You may have forgotten to pass an argument to the type checker creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and shape all require an argument).", d || "React class", u, p, typeof h), ce(null)), h instanceof Error && !(h.message in Ue) && (Ue[h.message] = !0, ce(g), E("Failed %s type: %s", u, h.message), ce(null));
          }
      }
    }
    var St = Array.isArray;
    function we(i) {
      return St(i);
    }
    function kt(i) {
      {
        var s = typeof Symbol == "function" && Symbol.toStringTag, u = s && i[Symbol.toStringTag] || i.constructor.name || "Object";
        return u;
      }
    }
    function Pt(i) {
      try {
        return ze(i), !1;
      } catch {
        return !0;
      }
    }
    function ze(i) {
      return "" + i;
    }
    function Ge(i) {
      if (Pt(i))
        return E("The provided key is an unsupported type %s. This value must be coerced to a string before before using it here.", kt(i)), ze(i);
    }
    var Z = _.ReactCurrentOwner, Tt = {
      key: !0,
      ref: !0,
      __self: !0,
      __source: !0
    }, Ke, He, ye;
    ye = {};
    function Ot(i) {
      if (ue.call(i, "ref")) {
        var s = Object.getOwnPropertyDescriptor(i, "ref").get;
        if (s && s.isReactWarning)
          return !1;
      }
      return i.ref !== void 0;
    }
    function At(i) {
      if (ue.call(i, "key")) {
        var s = Object.getOwnPropertyDescriptor(i, "key").get;
        if (s && s.isReactWarning)
          return !1;
      }
      return i.key !== void 0;
    }
    function Nt(i, s) {
      if (typeof i.ref == "string" && Z.current && s && Z.current.stateNode !== s) {
        var u = W(Z.current.type);
        ye[u] || (E('Component "%s" contains the string ref "%s". Support for string refs will be removed in a future major release. This case cannot be automatically converted to an arrow function. We ask you to manually fix this case by using useRef() or createRef() instead. Learn more about using refs safely here: https://reactjs.org/link/strict-mode-string-ref', W(Z.current.type), i.ref), ye[u] = !0);
      }
    }
    function Dt(i, s) {
      {
        var u = function() {
          Ke || (Ke = !0, E("%s: `key` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", s));
        };
        u.isReactWarning = !0, Object.defineProperty(i, "key", {
          get: u,
          configurable: !0
        });
      }
    }
    function It(i, s) {
      {
        var u = function() {
          He || (He = !0, E("%s: `ref` is not a prop. Trying to access it will result in `undefined` being returned. If you need to access the same value within the child component, you should pass it as a different prop. (https://reactjs.org/link/special-props)", s));
        };
        u.isReactWarning = !0, Object.defineProperty(i, "ref", {
          get: u,
          configurable: !0
        });
      }
    }
    var jt = function(i, s, u, d, g, x, p) {
      var h = {
        $$typeof: e,
        type: i,
        key: s,
        ref: u,
        props: p,
        _owner: x
      };
      return h._store = {}, Object.defineProperty(h._store, "validated", {
        configurable: !1,
        enumerable: !1,
        writable: !0,
        value: !1
      }), Object.defineProperty(h, "_self", {
        configurable: !1,
        enumerable: !1,
        writable: !1,
        value: d
      }), Object.defineProperty(h, "_source", {
        configurable: !1,
        enumerable: !1,
        writable: !1,
        value: g
      }), Object.freeze && (Object.freeze(h.props), Object.freeze(h)), h;
    };
    function Ft(i, s, u, d, g) {
      {
        var x, p = {}, h = null, k = null;
        u !== void 0 && (Ge(u), h = "" + u), At(s) && (Ge(s.key), h = "" + s.key), Ot(s) && (k = s.ref, Nt(s, g));
        for (x in s)
          ue.call(s, x) && !Tt.hasOwnProperty(x) && (p[x] = s[x]);
        if (i && i.defaultProps) {
          var b = i.defaultProps;
          for (x in b)
            p[x] === void 0 && (p[x] = b[x]);
        }
        if (h || k) {
          var C = typeof i == "function" ? i.displayName || i.name || "Unknown" : i;
          h && Dt(p, C), k && It(p, C);
        }
        return jt(i, h, k, g, d, Z.current, p);
      }
    }
    var be = _.ReactCurrentOwner, qe = _.ReactDebugCurrentFrame;
    function H(i) {
      if (i) {
        var s = i._owner, u = le(i.type, i._source, s ? s.type : null);
        qe.setExtraStackFrame(u);
      } else
        qe.setExtraStackFrame(null);
    }
    var Ce;
    Ce = !1;
    function _e(i) {
      return typeof i == "object" && i !== null && i.$$typeof === e;
    }
    function Je() {
      {
        if (be.current) {
          var i = W(be.current.type);
          if (i)
            return `

Check the render method of \`` + i + "`.";
        }
        return "";
      }
    }
    function Mt(i) {
      {
        if (i !== void 0) {
          var s = i.fileName.replace(/^.*[\\\/]/, ""), u = i.lineNumber;
          return `

Check your code at ` + s + ":" + u + ".";
        }
        return "";
      }
    }
    var Xe = {};
    function Lt(i) {
      {
        var s = Je();
        if (!s) {
          var u = typeof i == "string" ? i : i.displayName || i.name;
          u && (s = `

Check the top-level render call using <` + u + ">.");
        }
        return s;
      }
    }
    function Ze(i, s) {
      {
        if (!i._store || i._store.validated || i.key != null)
          return;
        i._store.validated = !0;
        var u = Lt(s);
        if (Xe[u])
          return;
        Xe[u] = !0;
        var d = "";
        i && i._owner && i._owner !== be.current && (d = " It was passed a child from " + W(i._owner.type) + "."), H(i), E('Each child in a list should have a unique "key" prop.%s%s See https://reactjs.org/link/warning-keys for more information.', u, d), H(null);
      }
    }
    function Qe(i, s) {
      {
        if (typeof i != "object")
          return;
        if (we(i))
          for (var u = 0; u < i.length; u++) {
            var d = i[u];
            _e(d) && Ze(d, s);
          }
        else if (_e(i))
          i._store && (i._store.validated = !0);
        else if (i) {
          var g = P(i);
          if (typeof g == "function" && g !== i.entries)
            for (var x = g.call(i), p; !(p = x.next()).done; )
              _e(p.value) && Ze(p.value, s);
        }
      }
    }
    function Wt(i) {
      {
        var s = i.type;
        if (s == null || typeof s == "string")
          return;
        var u;
        if (typeof s == "function")
          u = s.propTypes;
        else if (typeof s == "object" && (s.$$typeof === f || s.$$typeof === y))
          u = s.propTypes;
        else
          return;
        if (u) {
          var d = W(s);
          Rt(u, i.props, "prop", d, i);
        } else if (s.PropTypes !== void 0 && !Ce) {
          Ce = !0;
          var g = W(s);
          E("Component %s declared `PropTypes` instead of `propTypes`. Did you misspell the property assignment?", g || "Unknown");
        }
        typeof s.getDefaultProps == "function" && !s.getDefaultProps.isReactClassApproved && E("getDefaultProps is only used on classic React.createClass definitions. Use a static property named `defaultProps` instead.");
      }
    }
    function $t(i) {
      {
        for (var s = Object.keys(i.props), u = 0; u < s.length; u++) {
          var d = s[u];
          if (d !== "children" && d !== "key") {
            H(i), E("Invalid prop `%s` supplied to `React.Fragment`. React.Fragment can only have `key` and `children` props.", d), H(null);
            break;
          }
        }
        i.ref !== null && (H(i), E("Invalid attribute `ref` supplied to `React.Fragment`."), H(null));
      }
    }
    function et(i, s, u, d, g, x) {
      {
        var p = Et(i);
        if (!p) {
          var h = "";
          (i === void 0 || typeof i == "object" && i !== null && Object.keys(i).length === 0) && (h += " You likely forgot to export your component from the file it's defined in, or you might have mixed up default and named imports.");
          var k = Mt(g);
          k ? h += k : h += Je();
          var b;
          i === null ? b = "null" : we(i) ? b = "array" : i !== void 0 && i.$$typeof === e ? (b = "<" + (W(i.type) || "Unknown") + " />", h = " Did you accidentally export a JSX literal instead of a component?") : b = typeof i, E("React.jsx: type is invalid -- expected a string (for built-in components) or a class/function (for composite components) but got: %s.%s", b, h);
        }
        var C = Ft(i, s, u, g, x);
        if (C == null)
          return C;
        if (p) {
          var j = s.children;
          if (j !== void 0)
            if (d)
              if (we(j)) {
                for (var q = 0; q < j.length; q++)
                  Qe(j[q], i);
                Object.freeze && Object.freeze(j);
              } else
                E("React.jsx: Static children should always be an array. You are likely explicitly calling React.jsxs or React.jsxDEV. Use the Babel transform instead.");
            else
              Qe(j, i);
        }
        return i === n ? $t(C) : Wt(C), C;
      }
    }
    function Bt(i, s, u) {
      return et(i, s, u, !0);
    }
    function Vt(i, s, u) {
      return et(i, s, u, !1);
    }
    var Ut = Vt, Yt = Bt;
    ee.Fragment = n, ee.jsx = Ut, ee.jsxs = Yt;
  }()), ee;
}
(function(r) {
  process.env.NODE_ENV === "production" ? r.exports = pr() : r.exports = gr();
})(Te);
const T = Te.exports.jsx, mr = Te.exports.jsxs, Er = (r) => {
  const {
    label: e,
    mark: t,
    onChange: n,
    heldCaret: a,
    className: o,
    style: c,
    readOnly: l
  } = r.useMark();
  return /* @__PURE__ */ T("span", {
    ref: t,
    style: c,
    className: o,
    contentEditable: !l,
    suppressContentEditableWarning: !0,
    onInput: (v) => {
      var y;
      a(v.currentTarget);
      const w = (y = v.currentTarget.textContent) != null ? y : "";
      n({
        label: w
      }, {
        silent: !0
      });
    },
    onPaste: xr,
    children: e
  });
};
function xr(r) {
  r.preventDefault();
  const e = r.clipboardData.getData("text");
  document.execCommand("insertText", !1, e);
}
const wr = () => {
  const r = K(NaN);
  return Kt(() => {
    Number.isNaN(r.current) || e();
  }), t;
  function e() {
    var a;
    const n = (a = window.getSelection()) == null ? void 0 : a.anchorNode;
    n && M.trySetIndex(n, r.current), r.current = NaN;
  }
  function t(n) {
    r.current = M.getCaretIndex(n);
  }
}, yr = (r) => {
  const { bus: e, props: { readOnly: t, spanStyle: n, spanClassName: a } } = O(), o = br(r), [c, l] = ie(r.piece.label), [f, v] = ie(r.piece.value), w = J((A, L) => {
    L != null && L.silent || (l(A.label), v(A.value)), e.send(R.Change, { key: r.key, value: { ...A } });
  }, []), y = J(() => {
    l(""), v(void 0), e.send(R.Delete, { key: r.key });
  }, []), S = wr();
  return { label: c, value: f, mark: o, onChange: w, onRemove: y, heldCaret: S, readOnly: t, style: n, className: a };
};
function br(r) {
  const e = K(null);
  return J((t) => {
    if (t && "current" in t) {
      r.ref = t;
      return;
    }
    e.current = t, r.ref = e;
  }, []);
}
function Cr({
  node: r
}) {
  var o, c, l;
  const {
    options: e,
    props: {
      Mark: t
    }
  } = O(), n = _r(r);
  if (!ft(r.piece))
    return /* @__PURE__ */ T(Er, {
      ...n
    });
  const a = (l = (c = (o = e[r.piece.childIndex]).initMark) == null ? void 0 : c.call(o, n)) != null ? l : n;
  return /* @__PURE__ */ T(t, {
    ...a
  });
}
function _r(r) {
  const e = yr.bind(null, r);
  return {
    label: r.piece.label,
    value: r.piece.value,
    useMark: e
  };
}
const Rr = ut(() => {
  const {
    bus: r,
    props: {
      className: e,
      style: t
    }
  } = O(), n = e ? nt + " " + e : nt, a = vr(), o = G(() => r.events, []), c = ge();
  return hr(), /* @__PURE__ */ T("div", {
    ref: a,
    className: n,
    style: t,
    ...o,
    children: c.toArray().map((l) => /* @__PURE__ */ T(Cr, {
      node: l
    }, l.key))
  });
}), Sr = (r) => G(() => nr(r), [r]);
class fe {
  constructor(e, t, n, a) {
    this.data = e, this.prev = t, this.next = n, this.list = a;
  }
  get index() {
    if (!!this.list)
      return this.list.findIndex((e) => e === this.data);
  }
  insertBefore(e) {
    return this.list !== null ? this.list.insertBefore(this, e) : new V(e, this.data);
  }
  insertAfter(e) {
    return this.list !== null ? this.list.insertAfter(this, e) : new V(this.data, e);
  }
  remove() {
    if (this.list === null)
      throw new ReferenceError("Node does not belong to any list");
    return this.list.removeNode(this);
  }
}
class V {
  get length() {
    return this.size;
  }
  static from(e) {
    return new V(...e);
  }
  constructor(...e) {
    this.head = null, this.tail = null, this.size = 0;
    for (let t = 0; t < arguments.length; t++)
      this.append(arguments[t]);
  }
  get(e) {
    const t = this.getNode(e);
    return t !== void 0 ? t.data : void 0;
  }
  getNode(e) {
    if (this.head === null || e < 0 || e >= this.length)
      return;
    const t = e < this.length / 2, n = t ? e : this.length - e - 1, a = t ? "next" : "prev";
    let o = t ? this.head : this.tail;
    for (let c = 0; c < n; c++)
      o = o[a];
    return o;
  }
  findNodeIndex(e) {
    let t = 0, n = this.head;
    for (; n; ) {
      if (e(n.data, t, this))
        return {
          index: t,
          node: n
        };
      n = n.next, t += 1;
    }
  }
  findNode(e) {
    const t = this.findNodeIndex(e);
    return t !== void 0 ? t.node : void 0;
  }
  find(e) {
    const t = this.findNodeIndex(e);
    return t !== void 0 ? t.node.data : void 0;
  }
  findIndex(e) {
    const t = this.findNodeIndex(e);
    return t !== void 0 ? t.index : -1;
  }
  append(...e) {
    for (const t of e) {
      const n = new fe(t, this.tail, null, this);
      this.head === null && (this.head = n), this.tail !== null && (this.tail.next = n), this.tail = n, this.size += 1;
    }
    return this;
  }
  prepend(...e) {
    const t = Array.from(e).reverse();
    for (const n of t) {
      const a = new fe(n, null, this.head, this);
      this.tail === null && (this.tail = a), this.head !== null && (this.head.prev = a), this.head = a, this.size += 1;
    }
    return this;
  }
  insertAt(e, t) {
    if (this.head === null)
      return this.append(t);
    if (e <= 0)
      return this.prepend(t);
    let n = this.head, a = 0;
    for (; a < e - 1 && n.next !== null; )
      a += 1, n = n.next;
    return n.insertAfter(t), this;
  }
  removeNode(e) {
    if (e.list !== this)
      throw new ReferenceError("Node does not belong to this list");
    return e.prev !== null && (e.prev.next = e.next), e.next !== null && (e.next.prev = e.prev), this.head === e && (this.head = e.next), this.tail === e && (this.tail = e.prev), this.size -= 1, e.next = null, e.prev = null, e.list = null, e;
  }
  removeAt(e) {
    const t = this.getNode(e);
    return t !== void 0 ? this.removeNode(t) : void 0;
  }
  insertBefore(e, t) {
    const n = new fe(t, e.prev, e, this);
    return e.prev === null && (this.head = n), e.prev !== null && (e.prev.next = n), e.prev = n, this.size += 1, this;
  }
  sort(e) {
    if (this.head === null || this.tail === null)
      return this;
    if (this.length < 2)
      return this;
    const t = (n, a) => {
      if (n === a)
        return;
      const o = a.data;
      let c = n, l = n;
      for (; c && c !== a; ) {
        if (e(c.data, o)) {
          if (c !== l) {
            const v = l.data;
            l.data = c.data, c.data = v;
          }
          l = l.next;
        }
        c = c.next;
      }
      a.data = l.data, l.data = o, n.next !== a.prev && (l.prev && l !== n && t(n, l.prev), l.next && l !== a && t(l.next, a));
    };
    return t(this.head, this.tail), this;
  }
  insertAfter(e, t) {
    const n = new fe(t, e, e.next, this);
    return e.next === null && (this.tail = n), e.next !== null && (e.next.prev = n), e.next = n, this.size += 1, this;
  }
  shift() {
    return this.removeFromAnyEnd(this.head);
  }
  pop() {
    return this.removeFromAnyEnd(this.tail);
  }
  merge(e) {
    this.tail !== null && (this.tail.next = e.head), e.head !== null && (e.head.prev = this.tail), this.head = this.head || e.head, this.tail = e.tail || this.tail, this.size += e.size, e.size = this.size, e.head = this.head, e.tail = this.tail;
  }
  clear() {
    return this.head = null, this.tail = null, this.size = 0, this;
  }
  slice(e, t) {
    const n = new V();
    let a = t;
    if (this.head === null || this.tail === null)
      return n;
    (a === void 0 || a < e) && (a = this.length);
    let o = this.getNode(e);
    for (let c = 0; c < a - e && o !== null && o !== void 0; c++)
      n.append(o.data), o = o.next;
    return n;
  }
  reverse() {
    let e = this.head;
    for (; e; ) {
      const n = e.next;
      e.next = e.prev, e.prev = n, e = e.prev;
    }
    const t = this.tail;
    return this.tail = this.head, this.head = t, this;
  }
  forEach(e, t = !1) {
    let n = t ? this.length - 1 : 0, a = t ? this.tail : this.head;
    const o = t ? -1 : 1, c = t ? "prev" : "next";
    for (; a; )
      e(a.data, n, this), a = a[c], n += o;
  }
  map(e, t = !1) {
    const n = new V();
    return this.forEach((a, o) => n.append(e(a, o, this)), t), n;
  }
  filter(e, t = !1) {
    const n = new V();
    return this.forEach((a, o) => {
      e(a, o, this) && n.append(a);
    }, t), n;
  }
  reduce(e, t, n = !1) {
    let a = n ? this.length - 1 : 0;
    const o = n ? -1 : 1, c = n ? "prev" : "next";
    let l = n ? this.tail : this.head, f;
    if (t !== void 0)
      f = t;
    else if (l)
      f = l.data, l = l[c];
    else
      throw new TypeError("Reduce of empty LinkedList with no initial value");
    for (; l; )
      f = e(f, l.data, a, this), a += o, l = l[c];
    return f;
  }
  toArray() {
    return [...this];
  }
  toString(e = " ") {
    return this.reduce((t, n) => `${t}${e}${n}`);
  }
  *[Symbol.iterator]() {
    let e = this.head;
    for (; e !== null; )
      yield e.data, e = e.next;
  }
  removeFromAnyEnd(e) {
    return e !== null ? this.removeNode(e).data : void 0;
  }
}
const kr = (r, e) => {
  const t = G(pe.split(r, e), [r]), n = K(null);
  return G(() => {
    const a = /* @__PURE__ */ new Set(), o = n.current;
    let c = t.map((l) => {
      const f = lr(l, a), v = o == null ? void 0 : o.findNode((w) => w.key === f);
      return v ? v.data : { key: f, piece: Pe(l) ? l : { label: l } };
    });
    return n.current = V.from(c), n.current;
  }, [t.length]);
};
var ht = (r, e, t) => {
  if (!e.has(r))
    throw TypeError("Cannot " + t);
}, z = (r, e, t) => (ht(r, e, "read from private field"), t ? t.call(r) : e.get(r)), de = (r, e, t) => {
  if (e.has(r))
    throw TypeError("Cannot add the same private member more than once");
  e instanceof WeakSet ? e.add(r) : e.set(r, t);
}, Re = (r, e, t) => (ht(r, e, "access private method"), t), Oe, ne, te, re, ve;
const vt = class {
  constructor(...r) {
    de(this, re), de(this, Oe, /* @__PURE__ */ new Map()), de(this, ne, /* @__PURE__ */ new Map()), de(this, te, {}), r.forEach((e) => z(this, ne).set(e, /* @__PURE__ */ new Set()));
  }
  get events() {
    let r = {};
    for (let e of z(this, ne).keys())
      r[e] = (t) => this.send(e, t);
    return r;
  }
  static withExternalEventsFrom(r) {
    const e = new Set(qt);
    return () => new vt(...e);
  }
  get(r) {
    if (z(this, te)[r])
      return z(this, te)[r];
    throw new Error(`The ${r} is not exist!`);
  }
  set(r, e) {
    z(this, te)[r] = e;
  }
  send(r, e) {
    Re(this, re, ve).call(this, r).forEach((t) => t(e));
  }
  listen(r, e) {
    return Re(this, re, ve).call(this, r).add(e), () => Re(this, re, ve).call(this, r).delete(e);
  }
};
let Pr = vt;
Oe = /* @__PURE__ */ new WeakMap();
ne = /* @__PURE__ */ new WeakMap();
te = /* @__PURE__ */ new WeakMap();
re = /* @__PURE__ */ new WeakSet();
ve = function(r) {
  const e = tr(r) ? z(this, ne) : z(this, Oe);
  return e.has(r) || e.set(r, /* @__PURE__ */ new Set()), e.get(r);
};
function Tr(r, e) {
  const {
    bus: t,
    options: n
  } = O();
  F(R.Change, (a) => {
    const {
      key: o,
      value: c
    } = a, l = e.find((v) => v.key === o);
    l && c && (l.piece.label = c.label, l.piece.value = c.value);
    const f = e.toArray().map((v) => v.piece);
    r(at(f, n));
  }, [e, r]), F(R.Delete, (a) => {
    const {
      key: o
    } = a, c = e.findNode((f) => f.key === o);
    c && c.remove();
    const l = e.toArray().map((f) => f.piece);
    r(at(l, n));
  }, [e, r]), F(R.Select, (a) => {
    const {
      value: o,
      trigger: {
        option: c,
        span: l,
        index: f,
        source: v
      }
    } = a, w = ke(c.markup, o.label, o.value), y = or(l, w, f, v), S = e.findNode((A) => A.piece.label === l);
    S && (S.data.piece.label = y, t.send(R.Change, {
      value: {
        label: y
      },
      key: S.data.key
    }));
  }, [e, r]);
}
function Or(r) {
  const {
    value: e,
    children: t,
    ...n
  } = r, {
    Overlay: a,
    spanStyle: o,
    spanClassName: c,
    style: l,
    className: f,
    readOnly: v,
    onChange: w,
    Mark: y
  } = n;
  return G(() => n, [a, o, c, l, f, v, w, y]);
}
const Ar = ({
  props: r,
  children: e
}) => {
  const t = Sr(r.children), n = ie(Pr.withExternalEventsFrom(r))[0], a = Or(r), o = G(() => ({
    options: t,
    bus: n,
    props: a
  }), [t, a, n]);
  return /* @__PURE__ */ T(ir.Provider, {
    value: o,
    children: /* @__PURE__ */ T(Nr, {
      value: r.value,
      onChange: r.onChange,
      children: e
    })
  });
};
function Nr({
  value: r,
  children: e,
  onChange: t
}) {
  const {
    options: n
  } = O(), a = kr(r, n);
  return Tr(t, a), /* @__PURE__ */ T(ar.Provider, {
    value: a,
    children: e
  });
}
class Ae {
  static find(e) {
    if (M.isSelectedPosition)
      return new Ae().find(e);
  }
  constructor() {
    let e = M.getCurrentPosition();
    this.node = M.getSelectedNode(), this.span = M.getFocusedSpan(), this.dividedText = this.getDividedTextBy(e);
  }
  getDividedTextBy(e) {
    return {
      left: this.span.slice(0, e),
      right: this.span.slice(e)
    };
  }
  find(e) {
    for (let t of e) {
      let n = this.matchInTextVia(t.trigger);
      if (n)
        return {
          value: n.word,
          source: n.annotation,
          index: n.index,
          span: this.span,
          node: this.node,
          option: t
        };
    }
  }
  matchInTextVia(e) {
    const t = this.matchRightPart(), n = this.matchLeftPart(e);
    if (n)
      return {
        word: n.word + t.word,
        annotation: n.annotation + t.word,
        index: n.index
      };
  }
  matchRightPart() {
    var t;
    const {
      right: e
    } = this.dividedText;
    return {
      word: (t = e.match(Jt)) == null ? void 0 : t[0]
    };
  }
  matchLeftPart(e) {
    var l;
    const t = this.makeTriggerRegex(e), {
      left: n
    } = this.dividedText, a = n.match(t);
    if (!a)
      return;
    const [o, c] = a;
    return {
      word: c,
      annotation: o,
      index: (l = a.index) != null ? l : 0
    };
  }
  makeTriggerRegex(e) {
    const t = he(e) + "(\\w*)$";
    return new RegExp(t);
  }
}
const Dr = () => {
  const [r, e] = ie(), {
    options: t
  } = O();
  return F(R.ClearTrigger, (n) => e(void 0), []), F(R.CheckTrigger, (n) => e(Ae.find(t)), [t]), r;
}, Ir = Ht(({
  trigger: r,
  style: e,
  onSelect: t
}, n) => {
  const [a, o] = ie(NaN), c = G(() => r.option.data.filter((l) => l.toLowerCase().indexOf(r.value.toLowerCase()) > -1), [r.value]);
  return c.length ? /* @__PURE__ */ T("ul", {
    ref: n,
    className: "mk-suggestions",
    style: e,
    children: c.map((l, f) => {
      let v;
      return f === a && (v = "mk-suggestion-active"), /* @__PURE__ */ T("li", {
        className: v,
        onClick: (w) => t({
          label: l,
          value: f.toString()
        }),
        children: l
      }, l);
    })
  }) : null;
});
function jr(r) {
  var c, l, f;
  const {
    bus: e
  } = O(), t = J(() => e.send(R.ClearTrigger), []), n = J((v) => e.send(R.Select, {
    value: v,
    trigger: r
  }), [r]), a = M.getAbsolutePosition(), o = {
    trigger: r,
    style: a,
    onSelect: n,
    onClose: t
  };
  return (f = (l = (c = r.option).initOverlay) == null ? void 0 : l.call(c, o)) != null ? f : o;
}
function Fr(r) {
  const {
    bus: e
  } = O();
  ae(() => {
    const t = (n) => {
      let a = n.target;
      a !== r.current && a !== e.get("TextRef").current && (a == null ? void 0 : a.parentElement) !== e.get("TextRef").current && e.send(R.ClearTrigger);
    };
    return document.addEventListener("click", t), () => document.removeEventListener("click", t);
  }, []);
}
function Mr() {
  const {
    bus: r
  } = O();
  ae(() => {
    const e = (t) => {
      t.key === Y.ESC && r.send(R.ClearTrigger);
    };
    return window.addEventListener("keydown", e), () => window.removeEventListener("keydown", e);
  }, []);
}
const Lr = (r) => {
  const e = K(null);
  Mr(), Fr(e);
  const t = jr(r), {
    props: {
      Overlay: n = Ir
    }
  } = O();
  return /* @__PURE__ */ T(n, {
    ref: e,
    ...t
  });
};
function Wr() {
  const {
    bus: r
  } = O(), e = J(sr(() => r.send(R.CheckTrigger), 20), []);
  F("onFocus", (t) => document.addEventListener("selectionchange", e, {}), []), F("onBlur", (t) => document.removeEventListener("selectionchange", e), []);
}
const $r = ut(() => {
  Wr();
  const r = Dr();
  return r ? /* @__PURE__ */ T(Lr, {
    ...r
  }, r.option.index) : null;
});
function Br(r) {
  return /* @__PURE__ */ mr(Ar, {
    props: r,
    children: [/* @__PURE__ */ T(Rr, {}), /* @__PURE__ */ T($r, {})]
  });
}
const Yr = ({
  trigger: r = "@",
  markup: e = "@[__label__](__value__)",
  data: t = [],
  ...n
}) => null;
function zr(r, e, t) {
  const n = er(e) ? {
    Mark: r,
    Overlay: e,
    children: t
  } : {
    Mark: r,
    children: e
  };
  return (a) => {
    const o = ct({}, a, n);
    return Br(o);
  };
}
export {
  Br as MarkedInput,
  Yr as Option,
  ke as annotate,
  zr as createMarkedInput,
  Ur as denote
};
//# sourceMappingURL=index.js.map
